import {Component, PropTypes, Children} from 'react';

import {portalItemShape, contextShape} from './util';

export default class PortalProvider extends Component {
  static propTypes = {
    children: PropTypes.element.isRequired,
    list: PropTypes.arrayOf(portalItemShape).isRequired,
  };

  static childContextTypes = {
    portal: PropTypes.arrayOf(contextShape).isRequired,
  };

  getChildContext() {
    return {
      portal: {
        list: this.props.list,
      },
    };
  }

  render() {
    return Children.only(this.props.children);
  }
}
