import {combineReducers} from 'redux';
import {HIDE, SHOW, UPDATE} from './action';

export default combineReducers({
  list: (state = [], action) => ({
    [HIDE]: (state, {payload}) => state
      .filter((item) => item.id !== payload),
    [SHOW]: (state, {payload}) => state
      .filter((item) => item.id !== payload)
      .concat([payload]),
    [UPDATE]: (state, {payload}) => state
      .map((item) => item.id === payload.id ? {...item, ...payload} : item),
  }[action.type] || (() => state))(state, action),
});
