import {createElement, PropTypes} from 'react';

import connectPortal from './connect';

import {portalItemShape, componentShape} from './util';

const render = ({components, list = [], render}) => createElement(render, {
  list: list
    .filter((item) => components.hasOwnProperty(item.type))
    .map((item) => ({...item, component: components[item.type]})),
});

render.displayName = 'PortalRoot';
render.propTypes = {
  list: PropTypes.arrayOf(portalItemShape).isRequired,
  components: PropTypes.objectOf(componentShape),
  render: PropTypes.func.isRequired,
};
render.defaultProps = {
  render: ,
};

export default connectPortal(({list}) =>
  <div>
    {list.map(
      ({props, type, id, hide, component}) =>
        createElement(component, {id, type, hide, ...props})
    )}
  </div>
);
