import {PropTypes} from 'react';

export const getDisplayName = (C) => C.displayName || C.name || 'Component';

export const componentShape = PropTypes.oneOfType([
  PropTypes.func,
  PropTypes.string,
]);

export const portalItemShape = PropTypes.shape({
  id: PropTypes.string.isRequired,
  type: PropTypes.string.isRequired,
  props: PropTypes.object,
  hide: PropTypes.func,
  component: componentShape,
});

export const contextShape = PropTypes.shape({
  list: PropTypes.arrayOf(portalItemShape),
});
